package 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.BlendMode;
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.ColorTransform;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	
	/**
	 * ...
	 * @author Shiu
	 */
	[SWF(width = 400, height = 100)]
	public class Collisions extends Sprite 
	{
		[Embed(source="enemy_1.png")]
		private var E1:Class
		[Embed(source="player_ship.png")]
		private var My:Class
		
		private var enemy:Bitmap;
		private var enemyV:Vector.<Bitmap>;
		private var enemyData:BitmapData;
		private var enemyDataV:Vector.<BitmapData>;
		
		private var myShip:Bitmap, myShipData:BitmapData;
		
		public function Collisions():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			enemyV = new Vector.<Bitmap>;
			enemyDataV = new Vector.<BitmapData>;
			
			for (var i:int = 0; i < 20; i++) 
			{
				enemy = new E1 as Bitmap;	addChild(enemy);
				enemy.name = "enemy" + i;
				enemy.x = 50
				enemy.y = Math.random() * 40;
				
				enemyData = new BitmapData(enemy.width, enemy.height,true, 0x00000000);
				enemyData.draw(enemy);
				
				enemyV.push(enemy);
				enemyDataV.push(enemyData);
			}
			
			myShip = new My as Bitmap;	addChild(myShip);
			myShip.x = 50
			myShip.y = 20
			myShipData = new BitmapData(myShip.width, myShip.height, true,0x00000000);
			myShipData.draw(myShip);
		}
		
		public function checkAgainstAll_1():void {
			for (var i:int = 0; i < enemyV.length; i++) {
				detect1(enemyV[i], enemyDataV[i], myShip, myShipData);
			}
		}
		
		public function checkAgainstAll_2():void {
			for (var i:int = 0; i < enemyV.length; i++) {
				detect2(enemyV[i], myShip);
			}
		}
		
		public function checkAgainstAll_3():void {
			for (var i:int = 0; i < enemyV.length; i++) {
				detect3(enemyV[i], myShip);
			}
		}
		
		private function detect1(b1:Bitmap, b1_bdat:BitmapData, b2:Bitmap, b2_bdat:BitmapData):Boolean
		{
			return b1_bdat.hitTest(new Point(b1.x, b1.y), 255, b2_bdat, new Point(b2.x, b2.y), 255)
		}
		
		private function detect2(b1:Bitmap, b2:Bitmap):Boolean
		{
			var rec_b1:Rectangle = b1.getBounds(stage);
			var rec_b2:Rectangle = b2.getBounds(stage);
			
			var b1M:Matrix = b1.transform.matrix;
			var b2M:Matrix = b2.transform.matrix;
			
			b1M.tx -= rec_b1.x;	b2M.tx -= rec_b1.x;
			b1M.ty -= rec_b1.y;	b2M.ty -= rec_b1.y;
			
			var b1_bdat:BitmapData = new BitmapData(rec_b1.width, rec_b1.height, true, 0x00000000);
			b1_bdat.draw(b1);
			var b2_bdat:BitmapData = new BitmapData(rec_b2.width, rec_b2.height, true, 0x00000000);
			b2_bdat.draw(b2);
			
			if (b1_bdat.hitTest(new Point(rec_b1.x, rec_b1.y), 255, b2_bdat, new Point(rec_b2.x, rec_b2.y), 255)) return true
			else return false;
		}
		
		private function detect3(b1:Bitmap, b2:Bitmap):Boolean
		{
			var rec_b1:Rectangle = b1.getBounds(stage);
			var rec_b2:Rectangle = b2.getBounds(stage);
			var intersec:Rectangle = rec_b1.intersection(rec_b2);
			
			if (intersec.isEmpty()) return false
			
			var b1M:Matrix = b1.transform.matrix;
			var b2M:Matrix = b2.transform.matrix;
			
			var intersec_bdat:BitmapData = new BitmapData(intersec.width, intersec.height, false, 0)
			b1M.tx -= intersec.x;	b1M.ty -= intersec.y
			b2M.tx -= intersec.x;	b2M.ty -= intersec.y
			
			intersec_bdat.draw(b1, b1M, new ColorTransform(1,1,1,1,255,-255,-255), BlendMode.ADD);
			intersec_bdat.draw(b2, b2M, new ColorTransform(1,1,1,1,-255,255,-255), BlendMode.ADD);
			
			var intersec_color:Rectangle = intersec_bdat.getColorBoundsRect(0xffffff, 0xffff00);
			if (intersec_color.isEmpty())	return false;
			else return true;
		}
	}
	
}