package 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	import flash.geom.Rectangle;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	
	/**
	 * ...
	 * @author Shiu
	 */
	[SWF(width = 400, height = 300)]
	public class DetectVisible2 extends Sprite 
	{
		[Embed(source = "boss1.png")]
		private var E1:Class
		[Embed(source="player_ship.png")]
		private var My:Class
		
		private var enemy1:Bitmap, myShip:Bitmap;
		private var myShipSp:Sprite;
		private var rec_e:Rectangle, rec_m:Rectangle;
		private var intersec:Rectangle, bdt_intersec:BitmapData, bm_intersec:Bitmap;
		private var lines:Sprite;
		private var t:TextField;
		
		public function DetectVisible2():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			enemy1 = new E1 as Bitmap;	addChild(enemy1);
			myShip = new My as Bitmap;	
			myShipSp = new Sprite; addChild(myShipSp);
			myShipSp.addChild(myShip);
			
			enemy1.x = stage.stageWidth >> 1;	myShipSp.x = stage.stageWidth >> 1;
			enemy1.y = stage.stageHeight * 0.2;	myShipSp.y = stage.stageHeight * 0.8;
			
			//drawing boxes around the sprite
			draw(enemy1.getBounds(stage), this, 0);
			draw(myShipSp.getBounds(stage), this, 0);
			
			//adding mouse interactivity
			myShipSp.addEventListener(MouseEvent.MOUSE_DOWN, start);
			myShipSp.addEventListener(MouseEvent.MOUSE_UP, end);
			
			//container for intersection lines
			lines = new Sprite;
			addChild(lines);
			
			//text indicator on the top lect corner
			t = new TextField();	addChild(t);
			t.autoSize = TextFieldAutoSize.LEFT;
			t.x = 0; t.y = 0;
			
			//the intersection area bitmap
			bm_intersec = new Bitmap();	addChild(bm_intersec);
		}
		
		private function start(e:MouseEvent):void 
		{
			e.target.startDrag();
			e.target.stage.addEventListener(Event.ENTER_FRAME, refresh);
		}
		
		private function end(e:MouseEvent):void 
		{
			e.target.stopDrag();
			e.target.stage.removeEventListener(Event.ENTER_FRAME, refresh);
		}
		
		private function refresh(e:Event):void 
		{
			//determining the bounding box of intersection area
			rec_e = enemy1.getBounds(stage);
			rec_m = myShipSp.getBounds(stage);
			intersec = rec_e.intersection(rec_m);
			
			//redraw the bounding box of both sprites
			this.graphics.clear();
			draw(enemy1.getBounds(stage), this, 0);
			draw(myShipSp.getBounds(stage), this, 0);
			
			//only draw bounding box of intersection area if there's one
			if (!intersec.isEmpty()){
				lines.graphics.clear();
				draw(intersec, lines);
				
				//to draw the intersection area and checking for overlapping of colored area
				var eM:Matrix = enemy1.transform.matrix;
				var myM:Matrix = myShipSp.transform.matrix;
				
				bdt_intersec = new BitmapData(intersec.width, intersec.height, false, 0)
				eM.tx -= intersec.x;	eM.ty -= intersec.y
				myM.tx -= intersec.x;	myM.ty -= intersec.y
				
				bdt_intersec.draw(enemy1, eM);
				bdt_intersec.draw(myShip, myM);
				
				bm_intersec.bitmapData = bdt_intersec;
				bm_intersec.x = 10
				bm_intersec.y = stage.stageHeight * 0.8 - bm_intersec.height;
				
				t.text = "Intersection area by red rectangle.\n"
			}
			else {
				t.text ="No intersection area."
			}
		}
		
		//drawing a bonuding box
		private function draw(rect:Rectangle, container:Sprite, lineColor:Number = 0xff0000):void 
		{
			with (container) {
				graphics.lineStyle(3, lineColor);
				graphics.moveTo(rect.left, rect.top);
				graphics.lineTo(rect.right, rect.top);
				graphics.lineTo(rect.right, rect.bottom);
				graphics.lineTo(rect.left, rect.bottom);
				graphics.lineTo(rect.left, rect.top);
			}
		}
	}
	
}